import { ButtonElement, CheckboxElement, ProgressElement, RangeElement, SwitchElement } from '@aybolit/core';
import { css } from 'lit-element';

var absButtonStyles = css`:host{outline:none}.button{display:inline-block;padding:.375rem .75rem;font-family:-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif;font-size:1rem;font-weight:400;line-height:1.5;color:var(--abs-contrast, var(--abs-button-color, #212529));text-align:center;text-decoration:none;vertical-align:middle;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;background-color:var(--abs-color, var(--abs-button-bg-color, #fff));border-color:var(--abs-color, var(--abs-button-border-color, transparent));border-style:solid;border-width:1px;border-radius:.25rem;transition:color .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out;--abs-focus-shadow: hsla( var(--abs-hsl, var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)), 0.25 )}.button:hover{color:var(--abs-button-color, #212529);text-decoration:none}.button:focus{outline:0;box-shadow:0 0 0 .2rem var(--abs-focus-shadow)}.button[disabled]{pointer-events:none;opacity:.65}.button:not([disabled]):active{color:var(--abs-button-color, #212529)}:host([size=large]) .button{padding:.5rem 1rem;font-size:1.25rem;line-height:1.5;border-radius:.3rem}:host([size=small]) .button{padding:.25rem .5rem;font-size:.875rem;line-height:1.5;border-radius:.2rem}@media(prefers-reduced-motion: reduce){.button{transition:none}}:host([theme=danger]) .button,:host([theme=warning]) .button,:host([theme=success]) .button,:host([theme=info]) .button,:host([theme=primary]) .button{border-color:transparent}:host([theme=danger]) .button:hover,:host([theme=warning]) .button:hover,:host([theme=success]) .button:hover,:host([theme=info]) .button:hover,:host([theme=primary]) .button:hover{color:var(--abs-contrast);border-color:transparent}:host([theme=danger]) .button:focus,:host([theme=warning]) .button:focus,:host([theme=success]) .button:focus,:host([theme=info]) .button:focus,:host([theme=primary]) .button:focus{color:var(--abs-contrast)}:host([theme=danger][outline]) .button,:host([theme=warning][outline]) .button,:host([theme=success][outline]) .button,:host([theme=info][outline]) .button,:host([theme=primary][outline]) .button{color:var(--abs-color);background-color:transparent;border-color:var(--abs-color)}:host([theme=danger][outline]) .button:hover,:host([theme=warning][outline]) .button:hover,:host([theme=success][outline]) .button:hover,:host([theme=info][outline]) .button:hover,:host([theme=primary][outline]) .button:hover,:host([theme=danger][outline]) .button:focus,:host([theme=warning][outline]) .button:focus,:host([theme=success][outline]) .button:focus,:host([theme=info][outline]) .button:focus,:host([theme=primary][outline]) .button:focus{color:var(--abs-contrast);background-color:var(--abs-color);border-color:var(--abs-color)}:host([theme=danger][outline]) .button[disabled],:host([theme=warning][outline]) .button[disabled],:host([theme=success][outline]) .button[disabled],:host([theme=info][outline]) .button[disabled],:host([theme=primary][outline]) .button[disabled]{color:var(--abs-color);background-color:transparent;border-color:var(--abs-color)}:host([theme=primary]:hover){--abs-l: calc(var(--abs-primary-l, 48) - 7.5)}:host([theme=primary]:active){--abs-l: calc(var(--abs-primary-l, 48) - 10)}:host([theme=primary][outline]:hover){--abs-l: calc(var(--abs-primary-l, 48))}:host([theme=info]:hover){--abs-l: calc(var(--abs-info-l, 41) - 7.5)}:host([theme=info]:active){--abs-l: calc(var(--abs-info-l, 41) - 10)}:host([theme=info][outline]:hover){--abs-l: calc(var(--abs-info-l, 41))}:host([theme=success]:hover){--abs-l: calc(var(--abs-success-l, 41) - 7.5)}:host([theme=success]:active){--abs-l: calc(var(--abs-success-l, 41) - 10)}:host([theme=success][outline]:hover){--abs-l: calc(var(--abs-success-l, 41))}:host([theme=warning]:hover){--abs-l: calc(var(--abs-warning-l, 60) - 7.5)}:host([theme=warning]:active){--abs-l: calc(var(--abs-warning-l, 60) - 10)}:host([theme=warning][outline]:hover){--abs-l: calc(var(--abs-warning-l, 60))}:host([theme=danger]:hover){--abs-l: calc(var(--abs-danger-l, 48) - 7.5)}:host([theme=danger]:active){--abs-l: calc(var(--abs-danger-l, 48) - 10)}:host([theme=danger][outline]:hover){--abs-l: calc(var(--abs-danger-l, 48))}`;

var absThemeStyles = css`:host{--contrast-ratio: 25}:host([theme=primary]){--abs-h: var(--abs-primary-h, 211);--abs-s: var(--abs-primary-s, 100);--abs-l: var(--abs-primary-l, 48);--abs-hsl: var(--abs-h), calc(var(--abs-s) * 1%), calc(var(--abs-l) * 1%);--abs-color: hsl(var(--abs-hsl));--abs-contrast: hsl( var(--abs-h), calc(var(--abs-s) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-l) - 49.999) + var(--abs-l) * 1% ) )}:host([theme=info]){--abs-h: var(--abs-info-h, 188);--abs-s: var(--abs-info-s, 78);--abs-l: var(--abs-info-l, 41);--abs-hsl: var(--abs-h), calc(var(--abs-s) * 1%), calc(var(--abs-l) * 1%);--abs-color: hsl(var(--abs-hsl));--abs-contrast: hsl( var(--abs-h), calc(var(--abs-s) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-l) - 49.999) + var(--abs-l) * 1% ) )}:host([theme=success]){--abs-h: var(--abs-success-h, 134);--abs-s: var(--abs-success-s, 61);--abs-l: var(--abs-success-l, 41);--abs-hsl: var(--abs-h), calc(var(--abs-s) * 1%), calc(var(--abs-l) * 1%);--abs-color: hsl(var(--abs-hsl));--abs-contrast: hsl( var(--abs-h), calc(var(--abs-s) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-l) - 49.999) + var(--abs-l) * 1% ) )}:host([theme=warning]){--abs-h: var(--abs-warning-h, 45);--abs-s: var(--abs-warning-s, 100);--abs-l: var(--abs-warning-l, 60);--abs-hsl: var(--abs-h), calc(var(--abs-s) * 1%), calc(var(--abs-l) * 1%);--abs-color: hsl(var(--abs-hsl));--abs-contrast: hsl( var(--abs-h), calc(var(--abs-s) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-l) - 49.999) + var(--abs-l) * 1% ) )}:host([theme=danger]){--abs-h: var(--abs-danger-h, 354);--abs-s: var(--abs-danger-s, 70);--abs-l: var(--abs-danger-l, 48);--abs-hsl: var(--abs-h), calc(var(--abs-s) * 1%), calc(var(--abs-l) * 1%);--abs-color: hsl(var(--abs-hsl));--abs-contrast: hsl( var(--abs-h), calc(var(--abs-s) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-l) - 49.999) + var(--abs-l) * 1% ) )}`;

class AbsButton extends ButtonElement {
  static get styles() {
    return [super.styles, absThemeStyles, absButtonStyles];
  }

}
customElements.define('abs-button', AbsButton);

var absCheckboxStyles = css`:host{outline:none}.checkbox{position:relative;box-sizing:border-box;display:inline-block;min-height:1.5rem;padding-left:1.5rem;font-family:-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif;line-height:1.5}.input{position:absolute;z-index:-1;opacity:0}.input:checked~.label::before{background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));box-shadow:none}.input:focus~.label{--abs-focus-shadow: hsla( var(--abs-hsl, var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)), 0.25 )}.input:focus~.label::before{box-shadow:0 0 0 .2rem var(--abs-focus-shadow)}.input:focus:not(:checked)~.label::before{border-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 25) * 1%))}.input:not(:disabled):active~.label::before{background-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%));border-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%));box-shadow:none}.input:disabled~.label{color:var(--abs-checkbox-disabled-text, #6c757d)}.input:disabled~.label::before{background-color:var(--abs-checkbox-disabled-bg, #e9ecef)}.input:checked~.label::after{display:inline-block}.input:indeterminate~.label::before{background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)))}.input:indeterminate~.label::after{display:inline-block;border-bottom:none;transform:rotate(90deg)}.input:disabled:checked~.label::before,.input:disabled:indeterminate~.label::before{background-color:hsla(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc(var(--abs-l, var(--abs-primary-l, 48)) * 1%), 0.5)}.label{position:relative;display:inline-block;margin-bottom:0;vertical-align:top;--abs-primary-contrast: hsl( var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc( (-2500 * (var(--contrast-ratio) * 1% / 100 + 1%)) / (var(--abs-primary-l, 48) - 49.999) + var(--abs-primary-l, 48) * 1% ) )}.label::before{position:absolute;top:.25rem;left:-1.5rem;box-sizing:border-box;display:block;width:1rem;height:1rem;pointer-events:none;content:"";background-color:#fff;border:solid 1px var(--abs-checkbox-border-color, #adb5bd);border-radius:.25rem;transition:background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}.label::after{position:absolute;top:.45rem;left:-1.125rem;box-sizing:border-box;display:none;width:.25rem;height:.5rem;content:"";border-color:var(--abs-contrast, var(--abs-primary-contrast));border-style:solid;border-width:.125rem;border-top:0;border-left:0;transform:rotate(45deg)}`;

class AbsCheckbox extends CheckboxElement {
  static get styles() {
    return [super.styles, absThemeStyles, absCheckboxStyles];
  }

}
customElements.define('abs-checkbox', AbsCheckbox);

var absProgressStyles = css`progress{height:1rem;color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));background-color:var(--abs-progress-bar-color, #e9ecef);border-radius:.25rem}progress::-webkit-progress-bar{background-color:transparent}progress::-webkit-progress-value{background-color:currentColor;transition:width .6s ease}progress::-moz-progress-bar{background-color:currentColor;transition:width .6s ease}progress::-ms-fill{background-color:currentColor;transition:width .6s ease}:host([striped]) progress::-webkit-progress-value{background-image:linear-gradient(45deg, rgba(255, 255, 255, 0.15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, 0.15) 50%, rgba(255, 255, 255, 0.15) 75%, transparent 75%, transparent);background-size:1rem 1rem}:host([striped]) progress::-moz-progress-bar{background-image:linear-gradient(45deg, rgba(255, 255, 255, 0.15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, 0.15) 50%, rgba(255, 255, 255, 0.15) 75%, transparent 75%, transparent);background-size:1rem 1rem}:host([striped]) progress::-ms-fill{background-image:linear-gradient(45deg, rgba(255, 255, 255, 0.15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, 0.15) 50%, rgba(255, 255, 255, 0.15) 75%, transparent 75%, transparent);background-size:1rem 1rem}:host([size=large]) progress{height:1.25rem}:host([size=small]) progress{height:.875rem}`;

class AbsProgress extends ProgressElement {
  static get styles() {
    return [super.styles, absThemeStyles, absProgressStyles];
  }

}
customElements.define('abs-progress', AbsProgress);

var absRangeStyles = css`.range{height:1.4rem;--abs-focus-shadow: hsla( var(--abs-hsl, var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)), 0.25 )}.range:focus{outline:none}.range:focus::-webkit-slider-thumb{box-shadow:0 0 0 1px #fff,0 0 0 .2rem var(--abs-focus-shadow)}.range:focus::-moz-range-thumb{box-shadow:0 0 0 1px #fff,0 0 0 .2rem var(--abs-focus-shadow)}.range:focus::-ms-thumb{box-shadow:0 0 0 1px #fff,0 0 0 .2rem var(--abs-focus-shadow)}.range::-webkit-slider-thumb{width:1rem;height:1rem;margin-top:-0.25rem;background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border-radius:1rem;transition:background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}.range::-webkit-slider-thumb:active{background-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%))}.range::-webkit-slider-runnable-track{height:.5rem;color:transparent;cursor:pointer;background-color:var(--abs-range-track-bg, #dee2e6);border-color:transparent;border-radius:1rem}.range::-moz-range-thumb{width:1rem;height:1rem;background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border-radius:1rem;transition:background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}.range::-moz-range-thumb:active{background-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%))}.range::-moz-range-track{height:.5rem;color:transparent;cursor:pointer;background-color:var(--abs-range-track-bg, #dee2e6);border-color:transparent;border-radius:1rem}.range::-ms-thumb{width:1rem;height:1rem;margin-top:0;margin-right:.2rem;margin-left:.2rem;background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border:0;border-radius:1rem;transition:background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}.range::-ms-thumb:active{background-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%))}.range::-ms-track{height:.5rem;cursor:pointer;background-color:transparent;border-color:transparent;border-width:.5rem}.range::-ms-fill-lower{background-color:var(--abs-range-track-bg, #dee2e6);border-radius:1rem}.range::-ms-fill-upper{margin-right:15px;background-color:var(--abs-range-track-bg, #dee2e6);border-radius:1rem}.range:disabled::-webkit-slider-thumb{background-color:var(--abs-range-disabled-bg, #adb5bd)}.range:disabled::-webkit-slider-runnable-track{cursor:default}.range:disabled::-moz-range-thumb{background-color:var(--abs-range-disabled-bg, #adb5bd)}.range:disabled::-moz-range-track{cursor:default}.range:disabled::-ms-thumb{background-color:var(--abs-range-disabled-bg, #adb5bd)}@media(prefers-reduced-motion: reduce){.range::-webkit-slider-thumb{transition:none}.range::-moz-range-thumb{transition:none}.range::-ms-thumb{transition:none}}`;

class AbsRange extends RangeElement {
  static get styles() {
    return [super.styles, absThemeStyles, absRangeStyles];
  }

}
customElements.define('abs-range', AbsRange);

var absSwitchStyles = css`:host{outline:none}.switch{position:relative;min-height:1.5rem;padding-left:2.25rem;font-family:-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif}.input{position:absolute;z-index:-1;outline:none;opacity:0}.input:checked~.label::before{background-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));border-color:var(--abs-color, hsl(var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)));box-shadow:none}.input:checked~.label::after{background-color:var(--abs-switch-on-thumb-bg, #fff);transform:translateX(0.75rem)}.input:focus~.label{--abs-focus-shadow: hsla( var(--abs-hsl, var(--abs-primary-h, 211), calc(var(--abs-primary-s, 100) * 1%), calc(var(--abs-primary-l, 48) * 1%)), 0.25 )}.input:focus~.label::before{box-shadow:0 0 0 .2rem var(--abs-focus-shadow)}.input:focus:not(:checked)~.label::before{border-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 25) * 1%))}.input:active:not(:disabled)~.label::before{background-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%));border-color:hsl(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc((var(--abs-l, var(--abs-primary-l, 48)) + 35) * 1%));box-shadow:none}.input:disabled~.label{color:var(--abs-switch-disabled-text, #6c757d)}.input:disabled~.label::before{background-color:var(--abs-switch-disabled-bg, #e9ecef)}.input:disabled:checked~.label::before{background-color:hsla(var(--abs-h, var(--abs-primary-h, 211)), calc(var(--abs-s, var(--abs-primary-s, 100)) * 1%), calc(var(--abs-l, var(--abs-primary-l, 48)) * 1%), 0.5)}.label{margin-bottom:0;font-size:1rem;line-height:1.5;vertical-align:top}.label::before{position:absolute;top:.25rem;left:-2.25rem;box-sizing:border-box;width:1.75rem;height:1rem;background-color:var(--abs-switch-off-track-bg, #fff);border:solid 1px var(--abs-switch-off-track-border, #adb5bd);border-radius:.5rem}.label::after{position:absolute;top:calc(0.25rem + 2px);left:calc(-2.25rem + 2px);width:calc(1rem - 4px);height:calc(1rem - 4px);background-color:var(--abs-switch-off-thumb-bg, #adb5bd);background-repeat:no-repeat;background-position:center center;background-size:50% 50%;border-radius:.5rem;transition:transform .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}@media(prefers-reduced-motion: reduce){.label::after{transition:none}}`;

class AbsSwitch extends SwitchElement {
  static get styles() {
    return [super.styles, absThemeStyles, absSwitchStyles];
  }

}
customElements.define('abs-switch', AbsSwitch);

export { AbsButton, AbsCheckbox, AbsProgress, AbsRange, AbsSwitch };
